#pragma once

#include <string>

#include "input_handler.h"

namespace roy {

    namespace ih {

        class dummy_ih : public input_handler
        {
        public:
            dummy_ih(void);
            dummy_ih(const std::string& id, bool block);

            virtual bool    OnLButtonDown(UINT nFlags, CPoint point);
            virtual bool    OnLButtonUp(UINT nFlags, CPoint point);
            virtual bool    OnLButtonDblClk(UINT nFlags, CPoint point);

            virtual bool    OnRButtonDown(UINT nFlags, CPoint point);
            virtual bool    OnRButtonUp(UINT nFlags, CPoint point);
            virtual bool    OnRButtonDblClk(UINT nFlags, CPoint point);

            virtual bool    OnMButtonDown(UINT nFlags, CPoint point);
            virtual bool    OnMButtonUp(UINT nFlags, CPoint point);
            virtual bool    OnMButtonDblClk(UINT nFlags, CPoint point);

            virtual bool    OnMouseWheel(UINT nFlags, short zDelta, CPoint point);

            virtual bool    OnMouseMove(UINT nFlags, CPoint point);

            virtual bool    OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
            virtual bool    OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);

            virtual void    OnEntering(void);
            virtual void    OnLeaving(void);

        protected:
            bool            _block;
            std::string     _id;
        };

    }

}